# Modules

## GET /sdk/apps/{SDK\_appName}/{SDK\_appVersion}/modules

> List App Modules

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"SDK Apps / Modules"}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["sdk-apps:read"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/sdk/apps/{SDK_appName}/{SDK_appVersion}/modules":{"get":{"tags":["SDK Apps / Modules"],"summary":"List App Modules","parameters":[{"name":"SDK_appName","in":"path","schema":{"type":"string"},"required":true},{"name":"SDK_appVersion","in":"path","schema":{"type":"string"},"required":true}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"appModules":{"type":"array","items":{"type":"object","properties":{"name":{"type":"string"},"label":{"type":"string"},"description":{"type":"string"},"typeId":{"type":"integer"},"public":{"type":"boolean"},"approved":{"type":"boolean"},"archived":{"type":"boolean"},"crud":{"type":"string"}}}}}}}}}}}}}}
```

## POST /sdk/apps/{SDK\_appName}/{SDK\_appVersion}/modules

> Create Module

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"SDK Apps / Modules"}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["sdk-apps:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/sdk/apps/{SDK_appName}/{SDK_appVersion}/modules":{"post":{"tags":["SDK Apps / Modules"],"summary":"Create Module","requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"name":{"type":"string"},"typeId":{"type":"integer","enum":[1,4,9,10,11,12],"default":4,"description":"Module type id. Allowed values:\n - 1 = TRIGGER (Trigger - polling) Use if you wish to watch for any changes in your app/service. Examples are Watch a New Book, which will be triggered whenever a new book has been added to the library.\n - 4 = ACTION Use if the API endpoint returns a single response. Examples are Create a book, Delete a book or Get a Book.\n - 9 = SEARCH Use if the API endpoint returns multiple items. An example is List Books that will find specific books according to search criteria.\n - 10 = CONVERGER (Instant Trigger / webhook) Use if the API endpoint has a webhook available (dedicated or shared). Example is Watch a New Event.\n - 11 = HITL (Responder) Use if you need to send a processed data back to a webhook.\n - 12 = RETURNER (Universal) Use if you want to enable users to perform an arbitrary API call to the service. Examples are Make an API Call and Execute a GraphQL Query.\n"},"label":{"type":"string"},"description":{"type":"string"},"moduleInitMode":{"type":"string","enum":["blank","example","module"],"default":"blank","description":"Module init mode:\n * `blank` -  Creates a new blank module (code is empty).\n * `example` - Creates a module from a `model` app (which contains the example codes).\n * `module` - Creates module from existing user's module.\n"},"moduleInitSource":{"type":"string","description":"Required when `moduleInitMode` is `module`. Specifies the name of the source module to clone."},"connection":{"type":"string","description":"The name of the connection to use.","nullable":true},"webhook":{"type":"string","description":"The name of the webhook to use.","nullable":true},"crud":{"type":"string","description":"The CRUD operation type.","nullable":true}},"required":["name","typeId"]}}}},"parameters":[{"name":"SDK_appName","in":"path","schema":{"type":"string"},"required":true},{"name":"SDK_appVersion","in":"path","schema":{"type":"string"},"required":true}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"appModule":{"type":"object","properties":{"name":{"type":"string"},"label":{"type":"string"},"description":{"type":"string"},"typeId":{"type":"integer"},"crud":{"type":"string"},"connection":{"type":"string"},"webhook":{"type":"string"}}}}}}}}}}}}}
```

## GET /sdk/apps/{SDK\_appName}/{SDK\_appVersion}/modules/{SDK\_moduleName}

> Get Module

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"SDK Apps / Modules"}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["sdk-apps:read"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/sdk/apps/{SDK_appName}/{SDK_appVersion}/modules/{SDK_moduleName}":{"get":{"tags":["SDK Apps / Modules"],"summary":"Get Module","parameters":[{"name":"SDK_appName","in":"path","schema":{"type":"string"},"required":true},{"name":"SDK_appVersion","in":"path","schema":{"type":"string"},"required":true},{"name":"SDK_moduleName","in":"path","schema":{"type":"string"},"required":true}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"appModule":{"type":"object","properties":{"name":{"type":"string"},"label":{"type":"string"},"description":{"type":"string"},"typeId":{"type":"integer"},"public":{"type":"boolean"},"approved":{"type":"boolean"},"archived":{"type":"boolean"},"crud":{"type":"string"},"connection":{"type":"string"},"altConnection":{"type":"string"},"webhook":{"type":"string"}}}}}}}}}}}}}
```

## DELETE /sdk/apps/{SDK\_appName}/{SDK\_appVersion}/modules/{SDK\_moduleName}

> Delete Module

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"SDK Apps / Modules"}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["sdk-apps:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/sdk/apps/{SDK_appName}/{SDK_appVersion}/modules/{SDK_moduleName}":{"delete":{"tags":["SDK Apps / Modules"],"summary":"Delete Module","parameters":[{"name":"SDK_appName","in":"path","schema":{"type":"string"},"required":true},{"name":"SDK_appVersion","in":"path","schema":{"type":"string"},"required":true},{"name":"SDK_moduleName","in":"path","schema":{"type":"string"},"required":true}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"appModule":{"type":"string"}}}}}}}}}}}
```

## Patch Module

> Updates a module.\<br /><br>

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"SDK Apps / Modules"}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["sdk-apps:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/sdk/apps/{SDK_appName}/{SDK_appVersion}/modules/{SDK_moduleName}":{"patch":{"tags":["SDK Apps / Modules"],"summary":"Patch Module","description":"Updates a module.<br />\n","requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"label":{"type":"string"},"description":{"type":"string"},"connection":{"type":"string"}}}}}},"parameters":[{"name":"SDK_appName","in":"path","schema":{"type":"string"},"required":true},{"name":"SDK_appVersion","in":"path","schema":{"type":"string"},"required":true},{"name":"SDK_moduleName","in":"path","schema":{"type":"string"},"required":true}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"appModule":{"type":"object","properties":{"name":{"type":"string"},"label":{"type":"string"},"description":{"type":"string"},"typeId":{"type":"integer"},"crud":{"type":"string"},"connection":{"type":"string"},"altConnection":{"type":"string"},"webhook":{"type":"string"}}}}}}}}}}}}}
```

## Set Module Section

> Available sections: api, epoch, parameters, expect, interface, samples, scope\<br /><br>

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"SDK Apps / Modules"}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["sdk-apps:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/sdk/apps/{SDK_appName}/{SDK_appVersion}/modules/{SDK_moduleName}/api":{"put":{"tags":["SDK Apps / Modules"],"summary":"Set Module Section","description":"Available sections: api, epoch, parameters, expect, interface, samples, scope<br />\n","requestBody":{"content":{"application/json":{"schema":{"anyOf":[{"additionalProperties":false,"type":"object","properties":{"url":{"minLength":1,"maxLength":512,"description":"Request URL","type":"string"},"baseUrl":{"minLength":1,"maxLength":512,"description":"Base URL for endpoints starting with /","type":"string"},"encodeUrl":{"default":true,"description":"This directive controls the encoding of URLs. It is on by default, so if you have any special characters in your URL, they will be automatically encoded. But there might be situations where you don't want your URL to be encoded automatically, or you want to control what parts of the URL are encoded. To do this, set this flag to false.","type":"boolean"},"method":{"description":"This directive specifies the HTTP method that will be used to issue the request.","anyOf":[{"default":"GET","anyOf":[{"enum":["GET"],"type":"string"},{"enum":["POST"],"type":"string"},{"enum":["PUT"],"type":"string"},{"enum":["PATCH"],"type":"string"},{"enum":["DELETE"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies headers that will be sent with the request.","type":"object","properties":{}},"qs":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the query string to use when making the request.","type":"object","properties":{}},"ca":{"maxLength":8192,"description":"Custom Certificate Authority","type":"string"},"body":{"description":"This directive specifies the request body.","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"type":{"anyOf":[{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["multipart/form-data"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["binary"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"temp":{"additionalProperties":{},"description":"The temp directive specifies an object, which can be used to create custom temporary variables. It also creates a temp variable in IML, through which you then access your variables. The temp collection is not persisted and will be lost after the module is done executing.","type":"object","properties":{}},"condition":{"default":true,"description":"This directive specifies whether to execute the request or not.","anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"description":"Specifies if to execute the request or not.","anyOf":[{"type":"boolean"},{"type":"string"}]},"default":{"description":"Specifies the module output when the condition is false.","anyOf":[{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"object","properties":{}},{"type":"string"}]}},"required":["condition"]}]},"aws":{"additionalProperties":false,"description":"Helper directive, that will simplify generating AWS signatures.","type":"object","properties":{"key":{"maxLength":512,"description":"AWS key","type":"string"},"secret":{"maxLength":512,"description":"AWS secret","type":"string"},"session":{"maxLength":512,"description":"AWS session. Note that this only works for services that require session as part of the canonical string.","type":"string"},"bucket":{"maxLength":512,"description":"AWS bucket, unless you're specifying your bucket as part of the path, or the request doesn't use a bucket.","type":"string"},"sign_version":{"default":"2","description":"AWS sign version","anyOf":[{"enum":["2"],"type":"string"},{"enum":["4"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}}},"gzip":{"default":false,"description":"Add an Accept-Encoding header to request compressed content encodings from the server (if not already present) and decode supported content encodings in the response.","type":"boolean"},"followRedirects":{"default":true,"description":"This directive specifies whether to follow GET HTTP 3xx responses as redirects or never.","type":"boolean"},"followAllRedirects":{"default":true,"description":"This directive specifies whether to follow non-GET HTTP 3xx responses as redirects or never.","type":"boolean"},"log":{"additionalProperties":false,"description":"This directive specifies logging options for both the request and the response.","type":"object","properties":{"sanitize":{"description":"An array of paths to sanitize when logging request or response.","type":"array","items":{"type":"string"}}}},"oauth":{"additionalProperties":false,"description":"Helper directive, that will simplify generating an OAuth1 Authorization headers.","type":"object","properties":{"consumer_key":{"maxLength":512,"description":"Your consumer key.","type":"string"},"consumer_secret":{"maxLength":512,"description":"Your consumer secret.","type":"string"},"private_key":{"maxLength":512,"description":"Instead of consumer_secret you can specify a private_key string in PEM format.","type":"string"},"token":{"maxLength":512,"description":"An expression that parses the oauth_token string.","type":"string"},"token_secret":{"maxLength":512,"description":"An expression that parses the oauth_token_secret string.","type":"string"},"verifier":{"maxLength":512,"description":"An expression that parses the oauth_verifier string.","type":"string"},"signature_method":{"default":"HMAC-SHA1","description":"Specifies the desired method to use when calculating the signature.","anyOf":[{"enum":["HMAC-SHA1"],"type":"string"},{"enum":["RSA-SHA1"],"type":"string"},{"enum":["PLAINTEXT"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"transport_method":{"default":"header","description":"Specifies how OAuth parameters are sent: via query params, header or in a POST body.","anyOf":[{"enum":["query"],"type":"string"},{"enum":["body"],"type":"string"},{"enum":["header"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"body_hash":{"default":true,"description":"To use Request Body Hash, you can either manually generate it, or you can set this directive to true and the body hash will be generated automatically.","anyOf":[{"type":"string"},{"type":"boolean"}]}}},"pagination":{"additionalProperties":false,"description":"Directive to specify how to process paginated responses.","type":"object","properties":{"mergeWithParent":{"default":true,"description":"This directive specifies if to merge pagination parameters with the original request parameters, or not.","type":"boolean"},"url":{"minLength":1,"maxLength":512,"description":"This directive specifies the URL that will be called when the pagination request is executed.","type":"string"},"method":{"description":"This directive specifies the HTTP method to be used when executing the pagination request.","anyOf":[{"default":"GET","anyOf":[{"enum":["GET"],"type":"string"},{"enum":["POST"],"type":"string"},{"enum":["PUT"],"type":"string"},{"enum":["PATCH"],"type":"string"},{"enum":["DELETE"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the request headers to be used when executing the pagination request.","type":"object","properties":{}},"qs":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the request query string parameters to be used when executing the pagination request.","type":"object","properties":{}},"body":{"description":"This directive specifies the request body when the request method is anything but GET to be used when executing the pagination request.","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"condition":{"description":"This directive specifies whether to execute the pagination request or not.","anyOf":[{"type":"boolean"},{"type":"string"}]}}},"response":{"additionalProperties":false,"description":"Response parsing configuration","type":"object","properties":{"type":{"anyOf":[{"additionalProperties":{"anyOf":[{"default":"automatic","anyOf":[{"enum":["automatic"],"type":"string"},{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["binary"],"type":"string"},{"enum":["xml"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"type":"object","properties":{}},{"anyOf":[{"default":"automatic","anyOf":[{"enum":["automatic"],"type":"string"},{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["binary"],"type":"string"},{"enum":["xml"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}]},"valid":{"default":true,"anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"type":"string"},"message":{"type":"string"},"type":{"type":"string"}}}]},"limit":{"anyOf":[{"type":"number"},{"type":"string"}]},"error":{"anyOf":[{"description":"The error directive specifies the error type and the error message to show the user.","anyOf":[{"maxLength":1024,"type":"string"},{"required":["message"],"additionalProperties":{"required":["message"],"additionalProperties":false,"type":"object","properties":{"message":{"description":"An expression that parses an error message from response body.","maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}}},"description":"Error object. You can specify custom errors for different status codes by using the status code as the key (e.g., \"404\", \"500\").","type":"object","properties":{"message":{"description":"An expression that parses an error message from response body.","maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}}}]},{"additionalProperties":{"type":"object","properties":{"message":{"maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}},"required":["message"]},"type":"object","properties":{"message":{"maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}},"required":["message"]}]},"iterate":{"anyOf":[{"maxLength":512,"type":"string"},{"additionalProperties":false,"type":"object","properties":{"container":{"maxLength":512,"type":"string"},"condition":{"anyOf":[{"type":"string"},{"type":"boolean"}]}},"required":["container"]}]},"temp":{"additionalProperties":{},"description":"Temporary variables accessible during execution","type":"object","properties":{}},"output":{"anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"trigger":{"additionalProperties":false,"type":"object","properties":{"type":{"anyOf":[{"enum":["date"],"type":"string"},{"enum":["id"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"order":{"anyOf":[{"enum":["asc"],"type":"string"},{"enum":["desc"],"type":"string"},{"enum":["unordered"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"id":{"maxLength":512,"type":"string"},"date":{"maxLength":512,"type":"string"}},"required":["type","order","id"]},"data":{"additionalProperties":{},"description":"Data saved to connection","type":"object","properties":{}},"metadata":{"additionalProperties":true,"description":"Connection metadata","type":"object","properties":{"value":{"maxLength":512,"type":"string"},"type":{"anyOf":[{"enum":["text"],"type":"string"},{"enum":["email"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}}},"uid":{"description":"User remote service ID","anyOf":[{"type":"string"},{"type":"number"}]},"oauth":{"additionalProperties":false,"description":"Helper directive, that will simplify generating an OAuth1 Authorization headers.","type":"object","properties":{"consumer_key":{"maxLength":512,"description":"Your consumer key.","type":"string"},"consumer_secret":{"maxLength":512,"description":"Your consumer secret.","type":"string"},"private_key":{"maxLength":512,"description":"Instead of consumer_secret you can specify a private_key string in PEM format.","type":"string"},"token":{"maxLength":512,"description":"An expression that parses the oauth_token string.","type":"string"},"token_secret":{"maxLength":512,"description":"An expression that parses the oauth_token_secret string.","type":"string"},"verifier":{"maxLength":512,"description":"An expression that parses the oauth_verifier string.","type":"string"},"signature_method":{"default":"HMAC-SHA1","description":"Specifies the desired method to use when calculating the signature.","anyOf":[{"enum":["HMAC-SHA1"],"type":"string"},{"enum":["RSA-SHA1"],"type":"string"},{"enum":["PLAINTEXT"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"transport_method":{"default":"header","description":"Specifies how OAuth parameters are sent: via query params, header or in a POST body.","anyOf":[{"enum":["query"],"type":"string"},{"enum":["body"],"type":"string"},{"enum":["header"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"body_hash":{"default":true,"description":"To use Request Body Hash, you can either manually generate it, or you can set this directive to true and the body hash will be generated automatically.","anyOf":[{"type":"string"},{"type":"boolean"}]}}},"wrapper":{"default":"{{output}}","description":"Output post-processing wrapper","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"expires":{"minLength":1,"maxLength":512,"description":"Key expiration time for refresh triggers","type":"string"}}},"output":{"anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"iterate":{"anyOf":[{"maxLength":512,"type":"string"},{"additionalProperties":false,"type":"object","properties":{"container":{"maxLength":512,"type":"string"},"condition":{"anyOf":[{"type":"string"},{"type":"boolean"}]}},"required":["container"]}]},"respond":{"additionalProperties":false,"type":"object","properties":{"type":{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"}]},"status":{"anyOf":[{"minimum":100,"maximum":999,"type":"integer"},{"type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"Request headers","type":"object","properties":{}},"body":{"description":"Request body","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]}}},"verification":{"additionalProperties":false,"type":"object","properties":{"condition":{"default":true,"anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"anyOf":[{"type":"boolean"},{"type":"string"}]},"default":{"anyOf":[{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"object","properties":{}},{"type":"string"}]}},"required":["condition"]}]},"respond":{"additionalProperties":false,"type":"object","properties":{"type":{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"}]},"status":{"anyOf":[{"minimum":100,"maximum":999,"type":"integer"},{"type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"Request headers","type":"object","properties":{}},"body":{"description":"Request body","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]}}}}},"repeat":{"description":"Repeats a request under a certain condition with a predefined delay in milliseconds. The maximum number of repeats can be bounded by the repeat.limit.","type":"object","properties":{"condition":{"description":"Specifies if to execute the request or not.","type":"string"},"delay":{"description":"Specifies the delay in milliseconds.","type":"number"},"limit":{"description":"Specifies the maximum number of iterations.","type":"number"}}}}},{"type":"array","items":{"additionalProperties":false,"type":"object","properties":{"url":{"minLength":1,"maxLength":512,"description":"Request URL","type":"string"},"baseUrl":{"minLength":1,"maxLength":512,"description":"Base URL for endpoints starting with /","type":"string"},"encodeUrl":{"default":true,"description":"This directive controls the encoding of URLs. It is on by default, so if you have any special characters in your URL, they will be automatically encoded. But there might be situations where you don't want your URL to be encoded automatically, or you want to control what parts of the URL are encoded. To do this, set this flag to false.","type":"boolean"},"method":{"description":"This directive specifies the HTTP method that will be used to issue the request.","anyOf":[{"default":"GET","anyOf":[{"enum":["GET"],"type":"string"},{"enum":["POST"],"type":"string"},{"enum":["PUT"],"type":"string"},{"enum":["PATCH"],"type":"string"},{"enum":["DELETE"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies headers that will be sent with the request.","type":"object","properties":{}},"qs":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the query string to use when making the request.","type":"object","properties":{}},"ca":{"maxLength":8192,"description":"Custom Certificate Authority","type":"string"},"body":{"description":"This directive specifies the request body.","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"type":{"anyOf":[{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["multipart/form-data"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["binary"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"temp":{"additionalProperties":{},"description":"The temp directive specifies an object, which can be used to create custom temporary variables. It also creates a temp variable in IML, through which you then access your variables. The temp collection is not persisted and will be lost after the module is done executing.","type":"object","properties":{}},"condition":{"default":true,"description":"This directive specifies whether to execute the request or not.","anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"description":"Specifies if to execute the request or not.","anyOf":[{"type":"boolean"},{"type":"string"}]},"default":{"description":"Specifies the module output when the condition is false.","anyOf":[{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"object","properties":{}},{"type":"string"}]}},"required":["condition"]}]},"aws":{"additionalProperties":false,"description":"Helper directive, that will simplify generating AWS signatures.","type":"object","properties":{"key":{"maxLength":512,"description":"AWS key","type":"string"},"secret":{"maxLength":512,"description":"AWS secret","type":"string"},"session":{"maxLength":512,"description":"AWS session. Note that this only works for services that require session as part of the canonical string.","type":"string"},"bucket":{"maxLength":512,"description":"AWS bucket, unless you're specifying your bucket as part of the path, or the request doesn't use a bucket.","type":"string"},"sign_version":{"default":"2","description":"AWS sign version","anyOf":[{"enum":["2"],"type":"string"},{"enum":["4"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}}},"gzip":{"default":false,"description":"Add an Accept-Encoding header to request compressed content encodings from the server (if not already present) and decode supported content encodings in the response.","type":"boolean"},"followRedirects":{"default":true,"description":"This directive specifies whether to follow GET HTTP 3xx responses as redirects or never.","type":"boolean"},"followAllRedirects":{"default":true,"description":"This directive specifies whether to follow non-GET HTTP 3xx responses as redirects or never.","type":"boolean"},"log":{"additionalProperties":false,"description":"This directive specifies logging options for both the request and the response.","type":"object","properties":{"sanitize":{"description":"An array of paths to sanitize when logging request or response.","type":"array","items":{"type":"string"}}}},"oauth":{"additionalProperties":false,"description":"Helper directive, that will simplify generating an OAuth1 Authorization headers.","type":"object","properties":{"consumer_key":{"maxLength":512,"description":"Your consumer key.","type":"string"},"consumer_secret":{"maxLength":512,"description":"Your consumer secret.","type":"string"},"private_key":{"maxLength":512,"description":"Instead of consumer_secret you can specify a private_key string in PEM format.","type":"string"},"token":{"maxLength":512,"description":"An expression that parses the oauth_token string.","type":"string"},"token_secret":{"maxLength":512,"description":"An expression that parses the oauth_token_secret string.","type":"string"},"verifier":{"maxLength":512,"description":"An expression that parses the oauth_verifier string.","type":"string"},"signature_method":{"default":"HMAC-SHA1","description":"Specifies the desired method to use when calculating the signature.","anyOf":[{"enum":["HMAC-SHA1"],"type":"string"},{"enum":["RSA-SHA1"],"type":"string"},{"enum":["PLAINTEXT"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"transport_method":{"default":"header","description":"Specifies how OAuth parameters are sent: via query params, header or in a POST body.","anyOf":[{"enum":["query"],"type":"string"},{"enum":["body"],"type":"string"},{"enum":["header"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"body_hash":{"default":true,"description":"To use Request Body Hash, you can either manually generate it, or you can set this directive to true and the body hash will be generated automatically.","anyOf":[{"type":"string"},{"type":"boolean"}]}}},"pagination":{"additionalProperties":false,"description":"Directive to specify how to process paginated responses.","type":"object","properties":{"mergeWithParent":{"default":true,"description":"This directive specifies if to merge pagination parameters with the original request parameters, or not.","type":"boolean"},"url":{"minLength":1,"maxLength":512,"description":"This directive specifies the URL that will be called when the pagination request is executed.","type":"string"},"method":{"description":"This directive specifies the HTTP method to be used when executing the pagination request.","anyOf":[{"default":"GET","anyOf":[{"enum":["GET"],"type":"string"},{"enum":["POST"],"type":"string"},{"enum":["PUT"],"type":"string"},{"enum":["PATCH"],"type":"string"},{"enum":["DELETE"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the request headers to be used when executing the pagination request.","type":"object","properties":{}},"qs":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the request query string parameters to be used when executing the pagination request.","type":"object","properties":{}},"body":{"description":"This directive specifies the request body when the request method is anything but GET to be used when executing the pagination request.","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"condition":{"description":"This directive specifies whether to execute the pagination request or not.","anyOf":[{"type":"boolean"},{"type":"string"}]}}},"response":{"additionalProperties":false,"description":"Response parsing configuration","type":"object","properties":{"type":{"anyOf":[{"additionalProperties":{"anyOf":[{"default":"automatic","anyOf":[{"enum":["automatic"],"type":"string"},{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["binary"],"type":"string"},{"enum":["xml"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"type":"object","properties":{}},{"anyOf":[{"default":"automatic","anyOf":[{"enum":["automatic"],"type":"string"},{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["binary"],"type":"string"},{"enum":["xml"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}]},"valid":{"default":true,"anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"type":"string"},"message":{"type":"string"},"type":{"type":"string"}}}]},"limit":{"anyOf":[{"type":"number"},{"type":"string"}]},"error":{"anyOf":[{"description":"The error directive specifies the error type and the error message to show the user.","anyOf":[{"maxLength":1024,"type":"string"},{"required":["message"],"additionalProperties":{"required":["message"],"additionalProperties":false,"type":"object","properties":{"message":{"description":"An expression that parses an error message from response body.","maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}}},"description":"Error object. You can specify custom errors for different status codes by using the status code as the key (e.g., \"404\", \"500\").","type":"object","properties":{"message":{"description":"An expression that parses an error message from response body.","maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}}}]},{"additionalProperties":{"type":"object","properties":{"message":{"maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}},"required":["message"]},"type":"object","properties":{"message":{"maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}},"required":["message"]}]},"iterate":{"anyOf":[{"maxLength":512,"type":"string"},{"additionalProperties":false,"type":"object","properties":{"container":{"maxLength":512,"type":"string"},"condition":{"anyOf":[{"type":"string"},{"type":"boolean"}]}},"required":["container"]}]},"temp":{"additionalProperties":{},"description":"Temporary variables accessible during execution","type":"object","properties":{}},"output":{"anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"trigger":{"additionalProperties":false,"type":"object","properties":{"type":{"anyOf":[{"enum":["date"],"type":"string"},{"enum":["id"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"order":{"anyOf":[{"enum":["asc"],"type":"string"},{"enum":["desc"],"type":"string"},{"enum":["unordered"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"id":{"maxLength":512,"type":"string"},"date":{"maxLength":512,"type":"string"}},"required":["type","order","id"]},"data":{"additionalProperties":{},"description":"Data saved to connection","type":"object","properties":{}},"metadata":{"additionalProperties":true,"description":"Connection metadata","type":"object","properties":{"value":{"maxLength":512,"type":"string"},"type":{"anyOf":[{"enum":["text"],"type":"string"},{"enum":["email"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}}},"uid":{"description":"User remote service ID","anyOf":[{"type":"string"},{"type":"number"}]},"oauth":{"additionalProperties":false,"description":"Helper directive, that will simplify generating an OAuth1 Authorization headers.","type":"object","properties":{"consumer_key":{"maxLength":512,"description":"Your consumer key.","type":"string"},"consumer_secret":{"maxLength":512,"description":"Your consumer secret.","type":"string"},"private_key":{"maxLength":512,"description":"Instead of consumer_secret you can specify a private_key string in PEM format.","type":"string"},"token":{"maxLength":512,"description":"An expression that parses the oauth_token string.","type":"string"},"token_secret":{"maxLength":512,"description":"An expression that parses the oauth_token_secret string.","type":"string"},"verifier":{"maxLength":512,"description":"An expression that parses the oauth_verifier string.","type":"string"},"signature_method":{"default":"HMAC-SHA1","description":"Specifies the desired method to use when calculating the signature.","anyOf":[{"enum":["HMAC-SHA1"],"type":"string"},{"enum":["RSA-SHA1"],"type":"string"},{"enum":["PLAINTEXT"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"transport_method":{"default":"header","description":"Specifies how OAuth parameters are sent: via query params, header or in a POST body.","anyOf":[{"enum":["query"],"type":"string"},{"enum":["body"],"type":"string"},{"enum":["header"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"body_hash":{"default":true,"description":"To use Request Body Hash, you can either manually generate it, or you can set this directive to true and the body hash will be generated automatically.","anyOf":[{"type":"string"},{"type":"boolean"}]}}},"wrapper":{"default":"{{output}}","description":"Output post-processing wrapper","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"expires":{"minLength":1,"maxLength":512,"description":"Key expiration time for refresh triggers","type":"string"}}},"output":{"anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"iterate":{"anyOf":[{"maxLength":512,"type":"string"},{"additionalProperties":false,"type":"object","properties":{"container":{"maxLength":512,"type":"string"},"condition":{"anyOf":[{"type":"string"},{"type":"boolean"}]}},"required":["container"]}]},"respond":{"additionalProperties":false,"type":"object","properties":{"type":{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"}]},"status":{"anyOf":[{"minimum":100,"maximum":999,"type":"integer"},{"type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"Request headers","type":"object","properties":{}},"body":{"description":"Request body","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]}}},"verification":{"additionalProperties":false,"type":"object","properties":{"condition":{"default":true,"anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"anyOf":[{"type":"boolean"},{"type":"string"}]},"default":{"anyOf":[{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"object","properties":{}},{"type":"string"}]}},"required":["condition"]}]},"respond":{"additionalProperties":false,"type":"object","properties":{"type":{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"}]},"status":{"anyOf":[{"minimum":100,"maximum":999,"type":"integer"},{"type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"Request headers","type":"object","properties":{}},"body":{"description":"Request body","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]}}}}},"repeat":{"description":"Repeats a request under a certain condition with a predefined delay in milliseconds. The maximum number of repeats can be bounded by the repeat.limit.","type":"object","properties":{"condition":{"description":"Specifies if to execute the request or not.","type":"string"},"delay":{"description":"Specifies the delay in milliseconds.","type":"number"},"limit":{"description":"Specifies the maximum number of iterations.","type":"number"}}}}}}]}},"application/jsonc":{"schema":{"anyOf":[{"additionalProperties":false,"type":"object","properties":{"url":{"minLength":1,"maxLength":512,"description":"Request URL","type":"string"},"baseUrl":{"minLength":1,"maxLength":512,"description":"Base URL for endpoints starting with /","type":"string"},"encodeUrl":{"default":true,"description":"This directive controls the encoding of URLs. It is on by default, so if you have any special characters in your URL, they will be automatically encoded. But there might be situations where you don't want your URL to be encoded automatically, or you want to control what parts of the URL are encoded. To do this, set this flag to false.","type":"boolean"},"method":{"description":"This directive specifies the HTTP method that will be used to issue the request.","anyOf":[{"default":"GET","anyOf":[{"enum":["GET"],"type":"string"},{"enum":["POST"],"type":"string"},{"enum":["PUT"],"type":"string"},{"enum":["PATCH"],"type":"string"},{"enum":["DELETE"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies headers that will be sent with the request.","type":"object","properties":{}},"qs":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the query string to use when making the request.","type":"object","properties":{}},"ca":{"maxLength":8192,"description":"Custom Certificate Authority","type":"string"},"body":{"description":"This directive specifies the request body.","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"type":{"anyOf":[{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["multipart/form-data"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["binary"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"temp":{"additionalProperties":{},"description":"The temp directive specifies an object, which can be used to create custom temporary variables. It also creates a temp variable in IML, through which you then access your variables. The temp collection is not persisted and will be lost after the module is done executing.","type":"object","properties":{}},"condition":{"default":true,"description":"This directive specifies whether to execute the request or not.","anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"description":"Specifies if to execute the request or not.","anyOf":[{"type":"boolean"},{"type":"string"}]},"default":{"description":"Specifies the module output when the condition is false.","anyOf":[{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"object","properties":{}},{"type":"string"}]}},"required":["condition"]}]},"aws":{"additionalProperties":false,"description":"Helper directive, that will simplify generating AWS signatures.","type":"object","properties":{"key":{"maxLength":512,"description":"AWS key","type":"string"},"secret":{"maxLength":512,"description":"AWS secret","type":"string"},"session":{"maxLength":512,"description":"AWS session. Note that this only works for services that require session as part of the canonical string.","type":"string"},"bucket":{"maxLength":512,"description":"AWS bucket, unless you're specifying your bucket as part of the path, or the request doesn't use a bucket.","type":"string"},"sign_version":{"default":"2","description":"AWS sign version","anyOf":[{"enum":["2"],"type":"string"},{"enum":["4"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}}},"gzip":{"default":false,"description":"Add an Accept-Encoding header to request compressed content encodings from the server (if not already present) and decode supported content encodings in the response.","type":"boolean"},"followRedirects":{"default":true,"description":"This directive specifies whether to follow GET HTTP 3xx responses as redirects or never.","type":"boolean"},"followAllRedirects":{"default":true,"description":"This directive specifies whether to follow non-GET HTTP 3xx responses as redirects or never.","type":"boolean"},"log":{"additionalProperties":false,"description":"This directive specifies logging options for both the request and the response.","type":"object","properties":{"sanitize":{"description":"An array of paths to sanitize when logging request or response.","type":"array","items":{"type":"string"}}}},"oauth":{"additionalProperties":false,"description":"Helper directive, that will simplify generating an OAuth1 Authorization headers.","type":"object","properties":{"consumer_key":{"maxLength":512,"description":"Your consumer key.","type":"string"},"consumer_secret":{"maxLength":512,"description":"Your consumer secret.","type":"string"},"private_key":{"maxLength":512,"description":"Instead of consumer_secret you can specify a private_key string in PEM format.","type":"string"},"token":{"maxLength":512,"description":"An expression that parses the oauth_token string.","type":"string"},"token_secret":{"maxLength":512,"description":"An expression that parses the oauth_token_secret string.","type":"string"},"verifier":{"maxLength":512,"description":"An expression that parses the oauth_verifier string.","type":"string"},"signature_method":{"default":"HMAC-SHA1","description":"Specifies the desired method to use when calculating the signature.","anyOf":[{"enum":["HMAC-SHA1"],"type":"string"},{"enum":["RSA-SHA1"],"type":"string"},{"enum":["PLAINTEXT"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"transport_method":{"default":"header","description":"Specifies how OAuth parameters are sent: via query params, header or in a POST body.","anyOf":[{"enum":["query"],"type":"string"},{"enum":["body"],"type":"string"},{"enum":["header"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"body_hash":{"default":true,"description":"To use Request Body Hash, you can either manually generate it, or you can set this directive to true and the body hash will be generated automatically.","anyOf":[{"type":"string"},{"type":"boolean"}]}}},"pagination":{"additionalProperties":false,"description":"Directive to specify how to process paginated responses.","type":"object","properties":{"mergeWithParent":{"default":true,"description":"This directive specifies if to merge pagination parameters with the original request parameters, or not.","type":"boolean"},"url":{"minLength":1,"maxLength":512,"description":"This directive specifies the URL that will be called when the pagination request is executed.","type":"string"},"method":{"description":"This directive specifies the HTTP method to be used when executing the pagination request.","anyOf":[{"default":"GET","anyOf":[{"enum":["GET"],"type":"string"},{"enum":["POST"],"type":"string"},{"enum":["PUT"],"type":"string"},{"enum":["PATCH"],"type":"string"},{"enum":["DELETE"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the request headers to be used when executing the pagination request.","type":"object","properties":{}},"qs":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the request query string parameters to be used when executing the pagination request.","type":"object","properties":{}},"body":{"description":"This directive specifies the request body when the request method is anything but GET to be used when executing the pagination request.","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"condition":{"description":"This directive specifies whether to execute the pagination request or not.","anyOf":[{"type":"boolean"},{"type":"string"}]}}},"response":{"additionalProperties":false,"description":"Response parsing configuration","type":"object","properties":{"type":{"anyOf":[{"additionalProperties":{"anyOf":[{"default":"automatic","anyOf":[{"enum":["automatic"],"type":"string"},{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["binary"],"type":"string"},{"enum":["xml"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"type":"object","properties":{}},{"anyOf":[{"default":"automatic","anyOf":[{"enum":["automatic"],"type":"string"},{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["binary"],"type":"string"},{"enum":["xml"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}]},"valid":{"default":true,"anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"type":"string"},"message":{"type":"string"},"type":{"type":"string"}}}]},"limit":{"anyOf":[{"type":"number"},{"type":"string"}]},"error":{"anyOf":[{"description":"The error directive specifies the error type and the error message to show the user.","anyOf":[{"maxLength":1024,"type":"string"},{"required":["message"],"additionalProperties":{"required":["message"],"additionalProperties":false,"type":"object","properties":{"message":{"description":"An expression that parses an error message from response body.","maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}}},"description":"Error object. You can specify custom errors for different status codes by using the status code as the key (e.g., \"404\", \"500\").","type":"object","properties":{"message":{"description":"An expression that parses an error message from response body.","maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}}}]},{"additionalProperties":{"type":"object","properties":{"message":{"maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}},"required":["message"]},"type":"object","properties":{"message":{"maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}},"required":["message"]}]},"iterate":{"anyOf":[{"maxLength":512,"type":"string"},{"additionalProperties":false,"type":"object","properties":{"container":{"maxLength":512,"type":"string"},"condition":{"anyOf":[{"type":"string"},{"type":"boolean"}]}},"required":["container"]}]},"temp":{"additionalProperties":{},"description":"Temporary variables accessible during execution","type":"object","properties":{}},"output":{"anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"trigger":{"additionalProperties":false,"type":"object","properties":{"type":{"anyOf":[{"enum":["date"],"type":"string"},{"enum":["id"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"order":{"anyOf":[{"enum":["asc"],"type":"string"},{"enum":["desc"],"type":"string"},{"enum":["unordered"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"id":{"maxLength":512,"type":"string"},"date":{"maxLength":512,"type":"string"}},"required":["type","order","id"]},"data":{"additionalProperties":{},"description":"Data saved to connection","type":"object","properties":{}},"metadata":{"additionalProperties":true,"description":"Connection metadata","type":"object","properties":{"value":{"maxLength":512,"type":"string"},"type":{"anyOf":[{"enum":["text"],"type":"string"},{"enum":["email"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}}},"uid":{"description":"User remote service ID","anyOf":[{"type":"string"},{"type":"number"}]},"oauth":{"additionalProperties":false,"description":"Helper directive, that will simplify generating an OAuth1 Authorization headers.","type":"object","properties":{"consumer_key":{"maxLength":512,"description":"Your consumer key.","type":"string"},"consumer_secret":{"maxLength":512,"description":"Your consumer secret.","type":"string"},"private_key":{"maxLength":512,"description":"Instead of consumer_secret you can specify a private_key string in PEM format.","type":"string"},"token":{"maxLength":512,"description":"An expression that parses the oauth_token string.","type":"string"},"token_secret":{"maxLength":512,"description":"An expression that parses the oauth_token_secret string.","type":"string"},"verifier":{"maxLength":512,"description":"An expression that parses the oauth_verifier string.","type":"string"},"signature_method":{"default":"HMAC-SHA1","description":"Specifies the desired method to use when calculating the signature.","anyOf":[{"enum":["HMAC-SHA1"],"type":"string"},{"enum":["RSA-SHA1"],"type":"string"},{"enum":["PLAINTEXT"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"transport_method":{"default":"header","description":"Specifies how OAuth parameters are sent: via query params, header or in a POST body.","anyOf":[{"enum":["query"],"type":"string"},{"enum":["body"],"type":"string"},{"enum":["header"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"body_hash":{"default":true,"description":"To use Request Body Hash, you can either manually generate it, or you can set this directive to true and the body hash will be generated automatically.","anyOf":[{"type":"string"},{"type":"boolean"}]}}},"wrapper":{"default":"{{output}}","description":"Output post-processing wrapper","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"expires":{"minLength":1,"maxLength":512,"description":"Key expiration time for refresh triggers","type":"string"}}},"output":{"anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"iterate":{"anyOf":[{"maxLength":512,"type":"string"},{"additionalProperties":false,"type":"object","properties":{"container":{"maxLength":512,"type":"string"},"condition":{"anyOf":[{"type":"string"},{"type":"boolean"}]}},"required":["container"]}]},"respond":{"additionalProperties":false,"type":"object","properties":{"type":{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"}]},"status":{"anyOf":[{"minimum":100,"maximum":999,"type":"integer"},{"type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"Request headers","type":"object","properties":{}},"body":{"description":"Request body","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]}}},"verification":{"additionalProperties":false,"type":"object","properties":{"condition":{"default":true,"anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"anyOf":[{"type":"boolean"},{"type":"string"}]},"default":{"anyOf":[{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"object","properties":{}},{"type":"string"}]}},"required":["condition"]}]},"respond":{"additionalProperties":false,"type":"object","properties":{"type":{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"}]},"status":{"anyOf":[{"minimum":100,"maximum":999,"type":"integer"},{"type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"Request headers","type":"object","properties":{}},"body":{"description":"Request body","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]}}}}},"repeat":{"description":"Repeats a request under a certain condition with a predefined delay in milliseconds. The maximum number of repeats can be bounded by the repeat.limit.","type":"object","properties":{"condition":{"description":"Specifies if to execute the request or not.","type":"string"},"delay":{"description":"Specifies the delay in milliseconds.","type":"number"},"limit":{"description":"Specifies the maximum number of iterations.","type":"number"}}}}},{"type":"array","items":{"additionalProperties":false,"type":"object","properties":{"url":{"minLength":1,"maxLength":512,"description":"Request URL","type":"string"},"baseUrl":{"minLength":1,"maxLength":512,"description":"Base URL for endpoints starting with /","type":"string"},"encodeUrl":{"default":true,"description":"This directive controls the encoding of URLs. It is on by default, so if you have any special characters in your URL, they will be automatically encoded. But there might be situations where you don't want your URL to be encoded automatically, or you want to control what parts of the URL are encoded. To do this, set this flag to false.","type":"boolean"},"method":{"description":"This directive specifies the HTTP method that will be used to issue the request.","anyOf":[{"default":"GET","anyOf":[{"enum":["GET"],"type":"string"},{"enum":["POST"],"type":"string"},{"enum":["PUT"],"type":"string"},{"enum":["PATCH"],"type":"string"},{"enum":["DELETE"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies headers that will be sent with the request.","type":"object","properties":{}},"qs":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the query string to use when making the request.","type":"object","properties":{}},"ca":{"maxLength":8192,"description":"Custom Certificate Authority","type":"string"},"body":{"description":"This directive specifies the request body.","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"type":{"anyOf":[{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["multipart/form-data"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["binary"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"temp":{"additionalProperties":{},"description":"The temp directive specifies an object, which can be used to create custom temporary variables. It also creates a temp variable in IML, through which you then access your variables. The temp collection is not persisted and will be lost after the module is done executing.","type":"object","properties":{}},"condition":{"default":true,"description":"This directive specifies whether to execute the request or not.","anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"description":"Specifies if to execute the request or not.","anyOf":[{"type":"boolean"},{"type":"string"}]},"default":{"description":"Specifies the module output when the condition is false.","anyOf":[{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"object","properties":{}},{"type":"string"}]}},"required":["condition"]}]},"aws":{"additionalProperties":false,"description":"Helper directive, that will simplify generating AWS signatures.","type":"object","properties":{"key":{"maxLength":512,"description":"AWS key","type":"string"},"secret":{"maxLength":512,"description":"AWS secret","type":"string"},"session":{"maxLength":512,"description":"AWS session. Note that this only works for services that require session as part of the canonical string.","type":"string"},"bucket":{"maxLength":512,"description":"AWS bucket, unless you're specifying your bucket as part of the path, or the request doesn't use a bucket.","type":"string"},"sign_version":{"default":"2","description":"AWS sign version","anyOf":[{"enum":["2"],"type":"string"},{"enum":["4"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}}},"gzip":{"default":false,"description":"Add an Accept-Encoding header to request compressed content encodings from the server (if not already present) and decode supported content encodings in the response.","type":"boolean"},"followRedirects":{"default":true,"description":"This directive specifies whether to follow GET HTTP 3xx responses as redirects or never.","type":"boolean"},"followAllRedirects":{"default":true,"description":"This directive specifies whether to follow non-GET HTTP 3xx responses as redirects or never.","type":"boolean"},"log":{"additionalProperties":false,"description":"This directive specifies logging options for both the request and the response.","type":"object","properties":{"sanitize":{"description":"An array of paths to sanitize when logging request or response.","type":"array","items":{"type":"string"}}}},"oauth":{"additionalProperties":false,"description":"Helper directive, that will simplify generating an OAuth1 Authorization headers.","type":"object","properties":{"consumer_key":{"maxLength":512,"description":"Your consumer key.","type":"string"},"consumer_secret":{"maxLength":512,"description":"Your consumer secret.","type":"string"},"private_key":{"maxLength":512,"description":"Instead of consumer_secret you can specify a private_key string in PEM format.","type":"string"},"token":{"maxLength":512,"description":"An expression that parses the oauth_token string.","type":"string"},"token_secret":{"maxLength":512,"description":"An expression that parses the oauth_token_secret string.","type":"string"},"verifier":{"maxLength":512,"description":"An expression that parses the oauth_verifier string.","type":"string"},"signature_method":{"default":"HMAC-SHA1","description":"Specifies the desired method to use when calculating the signature.","anyOf":[{"enum":["HMAC-SHA1"],"type":"string"},{"enum":["RSA-SHA1"],"type":"string"},{"enum":["PLAINTEXT"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"transport_method":{"default":"header","description":"Specifies how OAuth parameters are sent: via query params, header or in a POST body.","anyOf":[{"enum":["query"],"type":"string"},{"enum":["body"],"type":"string"},{"enum":["header"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"body_hash":{"default":true,"description":"To use Request Body Hash, you can either manually generate it, or you can set this directive to true and the body hash will be generated automatically.","anyOf":[{"type":"string"},{"type":"boolean"}]}}},"pagination":{"additionalProperties":false,"description":"Directive to specify how to process paginated responses.","type":"object","properties":{"mergeWithParent":{"default":true,"description":"This directive specifies if to merge pagination parameters with the original request parameters, or not.","type":"boolean"},"url":{"minLength":1,"maxLength":512,"description":"This directive specifies the URL that will be called when the pagination request is executed.","type":"string"},"method":{"description":"This directive specifies the HTTP method to be used when executing the pagination request.","anyOf":[{"default":"GET","anyOf":[{"enum":["GET"],"type":"string"},{"enum":["POST"],"type":"string"},{"enum":["PUT"],"type":"string"},{"enum":["PATCH"],"type":"string"},{"enum":["DELETE"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the request headers to be used when executing the pagination request.","type":"object","properties":{}},"qs":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the request query string parameters to be used when executing the pagination request.","type":"object","properties":{}},"body":{"description":"This directive specifies the request body when the request method is anything but GET to be used when executing the pagination request.","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"condition":{"description":"This directive specifies whether to execute the pagination request or not.","anyOf":[{"type":"boolean"},{"type":"string"}]}}},"response":{"additionalProperties":false,"description":"Response parsing configuration","type":"object","properties":{"type":{"anyOf":[{"additionalProperties":{"anyOf":[{"default":"automatic","anyOf":[{"enum":["automatic"],"type":"string"},{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["binary"],"type":"string"},{"enum":["xml"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"type":"object","properties":{}},{"anyOf":[{"default":"automatic","anyOf":[{"enum":["automatic"],"type":"string"},{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["binary"],"type":"string"},{"enum":["xml"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}]},"valid":{"default":true,"anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"type":"string"},"message":{"type":"string"},"type":{"type":"string"}}}]},"limit":{"anyOf":[{"type":"number"},{"type":"string"}]},"error":{"anyOf":[{"description":"The error directive specifies the error type and the error message to show the user.","anyOf":[{"maxLength":1024,"type":"string"},{"required":["message"],"additionalProperties":{"required":["message"],"additionalProperties":false,"type":"object","properties":{"message":{"description":"An expression that parses an error message from response body.","maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}}},"description":"Error object. You can specify custom errors for different status codes by using the status code as the key (e.g., \"404\", \"500\").","type":"object","properties":{"message":{"description":"An expression that parses an error message from response body.","maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}}}]},{"additionalProperties":{"type":"object","properties":{"message":{"maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}},"required":["message"]},"type":"object","properties":{"message":{"maxLength":1024,"type":"string"},"type":{"default":"RuntimeError","anyOf":[{"enum":["RuntimeError"],"type":"string"},{"enum":["DataError"],"type":"string"},{"enum":["RateLimitError"],"type":"string"},{"enum":["OutOfSpaceError"],"type":"string"},{"enum":["ConnectionError"],"type":"string"},{"enum":["InvalidConfigurationError"],"type":"string"},{"enum":["InvalidAccessTokenError"],"type":"string"},{"enum":["IncompleteDataError"],"type":"string"},{"enum":["DuplicateDataError"],"type":"string"}]}},"required":["message"]}]},"iterate":{"anyOf":[{"maxLength":512,"type":"string"},{"additionalProperties":false,"type":"object","properties":{"container":{"maxLength":512,"type":"string"},"condition":{"anyOf":[{"type":"string"},{"type":"boolean"}]}},"required":["container"]}]},"temp":{"additionalProperties":{},"description":"Temporary variables accessible during execution","type":"object","properties":{}},"output":{"anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"trigger":{"additionalProperties":false,"type":"object","properties":{"type":{"anyOf":[{"enum":["date"],"type":"string"},{"enum":["id"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"order":{"anyOf":[{"enum":["asc"],"type":"string"},{"enum":["desc"],"type":"string"},{"enum":["unordered"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"id":{"maxLength":512,"type":"string"},"date":{"maxLength":512,"type":"string"}},"required":["type","order","id"]},"data":{"additionalProperties":{},"description":"Data saved to connection","type":"object","properties":{}},"metadata":{"additionalProperties":true,"description":"Connection metadata","type":"object","properties":{"value":{"maxLength":512,"type":"string"},"type":{"anyOf":[{"enum":["text"],"type":"string"},{"enum":["email"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}}},"uid":{"description":"User remote service ID","anyOf":[{"type":"string"},{"type":"number"}]},"oauth":{"additionalProperties":false,"description":"Helper directive, that will simplify generating an OAuth1 Authorization headers.","type":"object","properties":{"consumer_key":{"maxLength":512,"description":"Your consumer key.","type":"string"},"consumer_secret":{"maxLength":512,"description":"Your consumer secret.","type":"string"},"private_key":{"maxLength":512,"description":"Instead of consumer_secret you can specify a private_key string in PEM format.","type":"string"},"token":{"maxLength":512,"description":"An expression that parses the oauth_token string.","type":"string"},"token_secret":{"maxLength":512,"description":"An expression that parses the oauth_token_secret string.","type":"string"},"verifier":{"maxLength":512,"description":"An expression that parses the oauth_verifier string.","type":"string"},"signature_method":{"default":"HMAC-SHA1","description":"Specifies the desired method to use when calculating the signature.","anyOf":[{"enum":["HMAC-SHA1"],"type":"string"},{"enum":["RSA-SHA1"],"type":"string"},{"enum":["PLAINTEXT"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"transport_method":{"default":"header","description":"Specifies how OAuth parameters are sent: via query params, header or in a POST body.","anyOf":[{"enum":["query"],"type":"string"},{"enum":["body"],"type":"string"},{"enum":["header"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"body_hash":{"default":true,"description":"To use Request Body Hash, you can either manually generate it, or you can set this directive to true and the body hash will be generated automatically.","anyOf":[{"type":"string"},{"type":"boolean"}]}}},"wrapper":{"default":"{{output}}","description":"Output post-processing wrapper","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"expires":{"minLength":1,"maxLength":512,"description":"Key expiration time for refresh triggers","type":"string"}}},"output":{"anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"iterate":{"anyOf":[{"maxLength":512,"type":"string"},{"additionalProperties":false,"type":"object","properties":{"container":{"maxLength":512,"type":"string"},"condition":{"anyOf":[{"type":"string"},{"type":"boolean"}]}},"required":["container"]}]},"respond":{"additionalProperties":false,"type":"object","properties":{"type":{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"}]},"status":{"anyOf":[{"minimum":100,"maximum":999,"type":"integer"},{"type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"Request headers","type":"object","properties":{}},"body":{"description":"Request body","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]}}},"verification":{"additionalProperties":false,"type":"object","properties":{"condition":{"default":true,"anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"anyOf":[{"type":"boolean"},{"type":"string"}]},"default":{"anyOf":[{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"object","properties":{}},{"type":"string"}]}},"required":["condition"]}]},"respond":{"additionalProperties":false,"type":"object","properties":{"type":{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["text"],"type":"string"}]},"status":{"anyOf":[{"minimum":100,"maximum":999,"type":"integer"},{"type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"Request headers","type":"object","properties":{}},"body":{"description":"Request body","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]}}}}},"repeat":{"description":"Repeats a request under a certain condition with a predefined delay in milliseconds. The maximum number of repeats can be bounded by the repeat.limit.","type":"object","properties":{"condition":{"description":"Specifies if to execute the request or not.","type":"string"},"delay":{"description":"Specifies the delay in milliseconds.","type":"number"},"limit":{"description":"Specifies the maximum number of iterations.","type":"number"}}}}}}]}}}},"parameters":[{"name":"SDK_appName","in":"path","schema":{"type":"string"},"required":true},{"name":"SDK_appVersion","in":"path","schema":{"type":"string"},"required":true},{"name":"SDK_moduleName","in":"path","schema":{"type":"string"},"required":true}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"url":{"type":"string"},"method":{"type":"string"},"qs":{"type":"object"},"body":{"type":"object"},"headers":{"type":"object"},"response":{"type":"object","properties":{"iterate":{"type":"string"},"trigger":{"type":"object","properties":{"id":{"type":"string"},"date":{"type":"string"},"type":{"type":"string"},"order":{"type":"string"}}},"output":{"type":"string"},"limit":{"type":"string"}}}}}}}}}}}}}
```

## Set Module Section

> Available sections: api, epoch, parameters, expect, interface, samples, scope\<br /><br>

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"SDK Apps / Modules"}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["sdk-apps:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/sdk/apps/{SDK_appName}/{SDK_appVersion}/modules/{SDK_moduleName}/epoch":{"put":{"tags":["SDK Apps / Modules"],"summary":"Set Module Section","description":"Available sections: api, epoch, parameters, expect, interface, samples, scope<br />\n","requestBody":{"content":{"application/json":{"schema":{"additionalProperties":false,"type":"object","properties":{"url":{"minLength":1,"maxLength":512,"description":"Request URL","type":"string"},"encodeUrl":{"default":true,"description":"This directive controls the encoding of URLs. It is on by default, so if you have any special characters in your URL, they will be automatically encoded. But there might be situations where you don't want your URL to be encoded automatically, or you want to control what parts of the URL are encoded. To do this, set this flag to false.","type":"boolean"},"method":{"anyOf":[{"default":"GET","anyOf":[{"enum":["GET"],"type":"string"},{"enum":["POST"],"type":"string"},{"enum":["PUT"],"type":"string"},{"enum":["PATCH"],"type":"string"},{"enum":["DELETE"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"Request headers","type":"object","properties":{}},"qs":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"Query string parameters","type":"object","properties":{}},"ca":{"maxLength":8192,"description":"Custom Certificate Authority","type":"string"},"body":{"description":"Request body","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"type":{"anyOf":[{"default":"json","anyOf":[{"enum":["json"],"type":"string"},{"enum":["urlencoded"],"type":"string"},{"enum":["multipart/form-data"],"type":"string"},{"enum":["text"],"type":"string"},{"enum":["string"],"type":"string"},{"enum":["raw"],"type":"string"},{"enum":["binary"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"temp":{"additionalProperties":{},"description":"Temporary variables accessible during execution","type":"object","properties":{}},"condition":{"default":true,"anyOf":[{"type":"boolean"},{"type":"string"},{"additionalProperties":false,"type":"object","properties":{"condition":{"anyOf":[{"type":"boolean"},{"type":"string"}]},"default":{"anyOf":[{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"object","properties":{}},{"type":"string"}]}},"required":["condition"]}]},"aws":{"additionalProperties":false,"description":"Helper directive, that will simplify generating AWS signatures.","type":"object","properties":{"key":{"maxLength":512,"description":"AWS key","type":"string"},"secret":{"maxLength":512,"description":"AWS secret","type":"string"},"session":{"maxLength":512,"description":"AWS session. Note that this only works for services that require session as part of the canonical string.","type":"string"},"bucket":{"maxLength":512,"description":"AWS bucket, unless you're specifying your bucket as part of the path, or the request doesn't use a bucket.","type":"string"},"sign_version":{"default":"2","description":"AWS sign version","anyOf":[{"enum":["2"],"type":"string"},{"enum":["4"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]}}},"oauth":{"additionalProperties":false,"description":"Helper directive, that will simplify generating an OAuth1 Authorization headers.","type":"object","properties":{"consumer_key":{"maxLength":512,"description":"Your consumer key.","type":"string"},"consumer_secret":{"maxLength":512,"description":"Your consumer secret.","type":"string"},"private_key":{"maxLength":512,"description":"Instead of consumer_secret you can specify a private_key string in PEM format.","type":"string"},"token":{"maxLength":512,"description":"An expression that parses the oauth_token string.","type":"string"},"token_secret":{"maxLength":512,"description":"An expression that parses the oauth_token_secret string.","type":"string"},"verifier":{"maxLength":512,"description":"An expression that parses the oauth_verifier string.","type":"string"},"signature_method":{"default":"HMAC-SHA1","description":"Specifies the desired method to use when calculating the signature.","anyOf":[{"enum":["HMAC-SHA1"],"type":"string"},{"enum":["RSA-SHA1"],"type":"string"},{"enum":["PLAINTEXT"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"transport_method":{"default":"header","description":"Specifies how OAuth parameters are sent: via query params, header or in a POST body.","anyOf":[{"enum":["query"],"type":"string"},{"enum":["body"],"type":"string"},{"enum":["header"],"type":"string"},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"body_hash":{"default":true,"description":"To use Request Body Hash, you can either manually generate it, or you can set this directive to true and the body hash will be generated automatically.","anyOf":[{"type":"string"},{"type":"boolean"}]}}},"gzip":{"default":false,"description":"Add an Accept-Encoding header to request compressed content encodings from the server (if not already present) and decode supported content encodings in the response.","type":"boolean"},"followRedirects":{"default":true,"description":"This directive specifies whether to follow GET HTTP 3xx responses as redirects or never.","type":"boolean"},"followAllRedirects":{"default":true,"description":"This directive specifies whether to follow non-GET HTTP 3xx responses as redirects or never.","type":"boolean"},"log":{"additionalProperties":false,"description":"This directive specifies logging options for both the request and the response.","type":"object","properties":{"sanitize":{"description":"An array of paths to sanitize when logging request or response.","type":"array","items":{"type":"string"}}}},"pagination":{"additionalProperties":false,"description":"Directive to specify how to process paginated responses.","type":"object","properties":{"mergeWithParent":{"default":true,"description":"This directive specifies if to merge pagination parameters with the original request parameters, or not.","type":"boolean"},"url":{"minLength":1,"maxLength":512,"description":"This directive specifies the URL that will be called when the pagination request is executed.","type":"string"},"method":{"description":"This directive specifies the HTTP method to be used when executing the pagination request.","anyOf":[{"default":"GET","anyOf":[{"enum":["GET"],"type":"string"},{"enum":["POST"],"type":"string"},{"enum":["PUT"],"type":"string"},{"enum":["PATCH"],"type":"string"},{"enum":["DELETE"],"type":"string"}]},{"pattern":"^.*[{][{].*[}][}].*$","type":"string"}]},"headers":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the request headers to be used when executing the pagination request.","type":"object","properties":{}},"qs":{"additionalProperties":{"anyOf":[{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"},{"type":"array","items":{}}]},"description":"This directive specifies the request query string parameters to be used when executing the pagination request.","type":"object","properties":{}},"body":{"description":"This directive specifies the request body when the request method is anything but GET to be used when executing the pagination request.","anyOf":[{"type":"object","properties":{}},{"type":"array","items":{}},{"type":"boolean"},{"type":"integer"},{"type":"string","nullable":true},{"type":"number"},{"type":"string"}]},"condition":{"description":"This directive specifies wheth
[...]
